#include "varargs.h"
#include "stdio.h"

FILE _iob[OPEN_MAX] = {
	{0,1},{1,1},{2,1}
	};

/** getc(fp) get char from stream */
getc(fp)
FILE *fp;
{
char c;

read(fp->fd,&c,1);
return(c);
}

/** putc(c,fp) put char to stream */
putc(c,fp)
char c;
FILE *fp;
{
write(fp->fd,&c,1);
}

/** getchar() get char from stdin */
getchar()
{

return(getc(stdin));
}

/** putchar(c) put char to stdout */
putchar(c)
int c;
{
putc(c,stdout);
}

void era_line(char *s){
	while(*s++) printf("\b \b");
}

/** gets(p) get line from stdin */
gets(p)
char *p;
{

fgets(p,MAXLN,stdin);
}

/** puts(p) put string to stdout */
puts(p)
char *p;
{

fputs(p,stdout);
putc('\n',stdout);
}

/** FILE *fopen(fname,mode) open stream */
FILE *fopen(fname,mode)
char *fname;
int mode;
{
int i,fd;

for (i=0;i<OPEN_MAX && _iob[i].valid;i++) ;
if (i == OPEN_MAX) return(0);
fd = open(fname,0,0);
if (fd == -1) return(0);
_iob[i].fd = fd;
_iob[i].valid = 1;
return(&_iob[i]);
}

/** fclose(fp) close stream */
fclose(fp)
FILE *fp;
{
close(fp->fd);
fp->valid = 0;
}

/** fgets(p,n,fp) get string from stream */
fgets(p,n,fp)
char *p;
int n;
FILE *fp;
{
int c;

n = read(fp->fd,p,n);
p[n] = 0;
}

/** fputs(string,fp) put string to stream */
fputs(p,fp)
char *p;
FILE *fp;
{

for (;*p;p++) putc(*p,fp);
}

/** fflush(fp) flush output buffer */
fflush(fp) 
FILE *fp;
{
}

/** sprintf(buf,fmt,va_alist) send formatted string to buf */
sprintf(buf,fmt,va_alist)
char *buf,*fmt;
va_dcl
{
va_list ap;

va_start(ap);
vsprintf(buf,fmt,ap);
va_end(ap);
}

/** fprintf(fp,fmt,va_alist) send formatted string to stream */
fprintf(fp,fmt,va_alist)
FILE *fp;
char *fmt;
va_dcl
{
va_list ap;

va_start(ap);
vfprintf(fp,fmt,ap);
va_end(ap);
}

vfprintf(fp,fmt,ap)
FILE *fp;
char *fmt;
va_list ap;
{
char buf[MAXLN+1];

vsprintf(buf,fmt,ap);
fputs(buf,fp);
}

