#include "stdio.h"
#include "termio.h"
#include "terms.h"

int p2681();
int sable();

#ifdef SABLE
struct p2681info sablesiodat = {(byte *)0xa0050000};
struct sableinfo sablecondat = {(byte *)0xbf000000};
#else
/* HTP board has one 2681 */
#ifdef MIPSEL
struct p2681info HTPdat = {(byte *)0xbe000000};
#else
struct p2681info HTPdat = {(byte *)0xbe000003};
#endif
#endif

ConfigEntry ConfigTable[] = {
#ifdef SABLE
{(Addr)&sablecondat,0,sable,1024},
#else
{(Addr)&HTPdat,0,p2681,1024,B9600},
{(Addr)&HTPdat,1,p2681,1024,B9600},
#endif
{0}};


