#include "mips.h"
#include "pmon.h"

word htow(byte *s, word *pw){
	*pw = 0;
	while(*s){
		*pw <<= 4;
		if('0' <= *s && *s <= '9')
			*pw += (word)(*s - '0');
		else if('a' <= *s && *s <= 'f')
			*pw += (word)(*s - 'a' + 10);
		else if('A' <= *s && *s <= 'F')
			*pw += (word)(*s - 'A' + 10);
		else
			return(1);
		++s;
	}
	return(0);
}

#define htouw(s, p)	htow((s), (word *)(p))

word htoh(byte *s, half *ph){
	word v;

	if(htow(s, &v))
		return(1);
	if(v & ~0xffffL)
		return(1);
	*ph = (half)v;
	return(0);
}

word htob(byte *s, byte *pb){
	word v;

	if(htow(s, &v))
		return(1);
	if(v & ~0xffL)
		return(1);
	*pb = (byte)v;
	return(0);
}

word dtow(byte *s, word *pw){
	*pw = 0;
	while(*s){
		*pw *= 10;
		if('0' <= *s && *s <= '9')
			*pw += (word)(*s - '0');
		else
			return(1);
		++s;
	}
	return(0);
}

