#include <stdio.h>

/* 
 * This program converts the output from 'nm' into S4 records suitable
 * for downloading symbols to LSI Logic's Prom Monitor.
 *
 * usage: nm -B <obj_file> | genS4rec > <file>
 */

main(argc,argv)
int argc;
char *argv[];
{
char buf[200],name[64];
unsigned long addr;
int len,csum;

while (gets(buf)) {
	sscanf(buf,"%x %*s %s",&addr,name);
	csum = 0;
	len = strlen(name)+8+2;
	printf("S4%02X%08X%s,%02x\n",len,addr,name,csum);
	}
}

